#! /bin/sh
#========================================================================
# ydadd adds days to a yyyyddd formatted date
# usage ydadd 1998312 { ,-}14
#
# Author: Mo Budlong <mo.budlong@sunworld.com>
#
# Source: SunWorld Online UNIX 101 columns:
#	http://www.sunworld.com/sunworldonline/swol-11-1998/swol-11-unix101.html
#	http://www.sunworld.com/swol-12-1998/swol-12-unix101.html?1201a
#
# [11-Dec-1998]
#========================================================================

# Read from the difference from the command lines
# and the date from the command line, or standard input
if [ X$2 = X ]
then
        read yd dif
else
        yd=$1
        dif=$2
fi

# Break it into pieces
d=`expr $yd % 1000`
y=`expr $yd / 1000`

# Add the number of days (if days is negative this results in
# a subtraction)
d=`expr $d \+ $dif`

# Extract the days in the year
diy=`yeardays $y`

# If the calculated day exceeds the days in the year,
# add one year to the year and subtract the days in the year from the
# calculated days. Extract the days in the new year and repeat
# test until you end up with a day number that falls within the
# days of the year
while [ `expr $d \> $diy` = 1 ]
do
        d=`expr $d - $diy`
        y=`expr $y \+ 1`
        diy=`yeardays $y`
done

# This is the reverse process. If the calculated number of days
# is less than 1, move back one year. Extract
# the days in this year and add the days in the year
# loop on this test until you end up with a number that
# falls within the days of the year
while [ `expr $d \< 1` = 1 ]
do
        y=`expr $y - 1`
        diy=`yeardays $y`
        d=`expr $d \+ $diy`
done

# put the year and day back together and echo the result

yd=`expr \( $y \* 1000 \) + $d`

echo $yd
